<template>
  <dashboard-layout>
    <Search
      :params="params"
      @onChangeParams="onChangeParams"
      @onSearch="onSearch"
      @onClearSearch="onClearSearch"
    />
    <List
      :products="products"
      :pagination="pagination"
      :page="params.page"
      @onChangePage="onChangeParams"
      @onDelete="onDelete"
    />
    <DialogDelete
      :dialogDelete="dialogDelete"
      :productDeleted="productDeleted"
      @onChangeDialogDelete="onChangeDialogDelete"
      @onReloadList="onSearch"
    />
  </dashboard-layout>
</template>

<script>
import Search from "../../components/product/table/Search.vue";
import List from "../../components/product/table/List.vue";
import DialogDelete from "../../components/product/data/DialogDelete.vue";
import productService from "../../services/productService";

export default {
  components: {
    Search,
    List,
    DialogDelete,
  },
  data() {
    return {
      params: {
        page: 1,
        productName: "",
        isSales: "",
        productPriceFrom: "",
        productPriceTo: "",
      },
      products: [],
      pagination: {
        from: 0,
        to: 0,
        total: 0,
        currentPage: 0,
        lastPage: 0,
      },
      productData: {},
      dialogDelete: false,
      productDeleted: {
        productId: '',
        productName: '',
      },
    };
  },
  methods: {
    async fetchData() {
      this.$store.commit("loading", true);
      await productService
        .getList(this.params)
        .then((response) => {
          this.$store.commit("loading", false);
          const responseData = response.data;
          this.products = responseData.data;
          this.pagination.from = responseData.from;
          this.pagination.to = responseData.to;
          this.pagination.total = responseData.total;
          this.pagination.currentPage = responseData.currentPage;
          this.pagination.lastPage = responseData.lastPage;
        })
        .catch((error) => {
          this.$store.commit("loading", false);
          let msgError = "";
          if (error.response.status === 422) {
            const dataErrors = error.response.data.errors;
            let errors = [];
            for (const [key, value] of Object.entries(dataErrors)) {
              errors.push(value);
            }
            msgError = errors.toString();
          } else {
            msgError = error.response.data.message;
          }
          this.$store.commit("showMessageError", msgError);
        });
    },
    onChangeParams({ key, value }) {
      this.params[key] = value;
      if (key === "page") {
        this.fetchData();
      }
    },
    onSearch() {
      this.params.page = 1;
      this.fetchData();
    },
    onClearSearch() {
      this.params = {
        page: 1,
        productName: "",
        isSales: "",
        productPriceFrom: "",
        productPriceTo: "",
      };
      this.fetchData();
    },
    async fetchDetailData(id) {
      this.$store.commit("loading", true);
      await productService
        .getById(id)
        .then((response) => {
          this.$store.commit("loading", false);
          this.productData = response.data;
          this.productData.password = "";
          this.productData.passwordConfirmation = "";
        })
        .catch((error) => {
          this.$store.commit("loading", false);
          let msgError = "";
          if (error.response.status === 422) {
            const dataErrors = error.response.data.errors;
            let errors = [];
            for (const [key, value] of Object.entries(dataErrors)) {
              errors.push(value);
            }
            msgError = errors.toString();
          } else {
            msgError = error.response.data.message;
          }
          this.$store.commit("showMessageError", msgError);
        });
    },
    async onDelete({productId, productName}) {
      this.productDeleted.productId = productId;
      this.productDeleted.productName = productName;
      this.onChangeDialogDelete(true);
    },
    onChangeDialogDelete(value) {
      this.dialogDelete = value;
    },
  },
  async created() {
    await this.fetchData();
  },
};
</script>
